Imports System.ComponentModel
Imports System.Globalization
Imports System.Reflection

<Serializable()> _
Public NotInheritable Class Field

    Private pImage As Image
    Private pText As String
    Friend ctrl As Control

    Property Image() As Image
        Get
            Return pImage
        End Get
        Set(ByVal value As Image)
            pImage = value
        End Set
    End Property
    Property Text() As String
        Get
            Return pText
        End Get
        Set(ByVal value As String)
            pText = value
        End Set
    End Property

    Dim p_ContextMenu As ContextMenu
    Property ContextMenu() As ContextMenu
        Get
            Return p_ContextMenu
        End Get
        Set(ByVal value As ContextMenu)
            p_ContextMenu = value
        End Set
    End Property

    Sub New()
    End Sub

    Sub New(ByVal Text As String, ByVal Image As Image)
        Me.Image = Image
        Me.Text = Text
    End Sub
End Class

Public NotInheritable Class FieldConverter
    Inherits TypeConverter
    Public Overloads Overrides Function CanConvertTo(ByVal context As ITypeDescriptorContext, ByVal destinationType As Type) As Boolean
        Return True
        If destinationType Is GetType(InstanceDescriptor) Then
            Return True
        End If
        Return MyBase.CanConvertTo(context, destinationType)
    End Function


    Public Overloads Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
        If destinationType Is GetType(InstanceDescriptor) Then
            Dim ctor As ConstructorInfo = GetType(Field).GetConstructor(New Type() {GetType(String), GetType(Image)})
            Dim v As Field

            If Type.Equals(value.GetType, GetType(Field)) Then
                v = CType(value, Field)
            Else
                MsgBox(value.GetType.FullName & vbCrLf & GetType(Field).FullName)
                v = New Field(String.Empty, Nothing)
            End If
            Dim id As Object = New InstanceDescriptor(ctor, New Object() {v.Text, v.Image}, True)
            Return id
        End If
        Return MyBase.ConvertTo(context, culture, value, destinationType)
    End Function
End Class