Friend Class IconButton

    Public Overrides Property Text() As String
        Get
            Return caption.Text
        End Get
        Set(ByVal value As String)
            Me.Width = caption.Left + Me.CreateGraphics.MeasureString(value, caption.Font).Width + 2
            caption.Text = value
        End Set
    End Property

    Public Property Image() As Image
        Get
            Return ImageBox.Image
        End Get
        Set(ByVal value As Image)
            ImageBox.Image = value
        End Set
    End Property

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        ' Me.Dock = DockStyle.Left
    End Sub

    Public Sub New(ByVal text As String, ByVal image As Image)
        Me.New()
        Me.ImageBox.Image = image
        Me.Text = text
    End Sub
    Private Sub ImageBox_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ImageBox.Resize
        Me.Height = 16
        Me.Width = caption.Left + Me.CreateGraphics.MeasureString(Me.caption.Text, caption.Font).Width + 2

    End Sub

    Private Sub Inner_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles caption.Click, ImageBox.Click
        Me.OnClick(e)
    End Sub
End Class
